﻿#New-SCCMCollectionWizard
#Written by Brian Kaler
#11/21/2018
#Description
#Creates AD group, adds Members, then creates a collection in SCCM based off membership
Param(
[Parameter(Mandatory)]
[String]$wizardmode="on"
)

$scriptname = "New-SCCMCollectionWizard"
#define the directory the scripts reside in
Write-host "INFO: Loading subscripts and modules, please wait..."
$scriptroot = (Get-Item -path ".\").FullName
#Include the subscripts
. $scriptroot\Add-computerstoadgroup.ps1
. $scriptroot\New-CollectionfromAD.ps1
#Load the SCCM Module
$SiteCode = "SSS" 
$SiteServer = "uswscm901.us.pinkertons.com" 
# Import the ConfigurationManager.psd1 module  
$scmod = Import-Module "$($ENV:SMS_ADMIN_UI_PATH)\..\ConfigurationManager.psd1" -PassThru
#import ActiveDirectory
$adsmod = Import-Module ActiveDirectory -PassThru
If($scmod -eq $null){
    Write-Host "ERROR: Could not find Configuration Manager Module, please confirm SCCM Admin Console is installed on this machine"
    Sleep -seconds 15
    exit
    }
If($adsmod -eq $null){
    Write-Host "ERROR: Could not find Active Directory Module, please confirm it is installed on the machine, `ntry running 'install-module activedirectory' as a potential fix"
    Sleep -seconds 15
    exit
    }
# Set the current location to be the site code. 
$siteloc = Set-Location $SiteCode":\"  
CLEAR

#-----------Start Wizard Interface----------------------------------#
If($wizardmode -eq "on"){
    
    Write-Host "INPUT: Choose a purpose for your SCCM deployment: "
    Write-Host "'1' for software updates"
    Write-Host "'2' for application/package push"
    Write-Host "'3' for client push"
    Write-Host "'4' for a generic server collection"
    $switch = Read-Host -Prompt "INPUT: Choose your Collection type"
    Switch ($switch)
        {
            1 {$groupnamepfx="MAINT-SERVER-"}
            2 {$groupnamepfx="APPPUSH-"}
            3 {$groupnamepfx="CLIENTPUSH-"}
            4 {$groupnamepfx="SERVERS-"}
        }
        Clear
    Write-Host "INFO: Provide a shortname for your group title: `nEXAMPLE: 'WINZIP12-SSS000FD' for Winzip Application Push with the ID 'SSS000FD' `n `
    EXAMPLE: 'DEVD2W1' for Software Updates for a group of DEV Servers"
    $inputgrouptitle = Read-Host
    $groupname = ($groupnamepfx+$inputgrouptitle)
    Switch ($switch)
        {
            1 {$folder="SoftwareUpdates"}
            2 {$folder="Applications"}
            3 {$folder="ClientPush"}
            4 {$folder="Servers"}
        }
        Clear
    If($switch -eq 2){
    Write-Host "INPUT: Choose a target (user/device) for your SCCM deployment: "
    Write-Host "'1' for User Deployment"
    Write-Host "'2' for Device Deployment"
    Switch ($switch)
    {
        1 {$deploy="User"}
        2 {$deploy="Device"}
    }
    Clear
    }
    
    Write-Host "INFO: your calculated AD group and SCCM collection will be: $groupname`n"
    Write-Host "INFO: you can find your AD group in the SCCM container under the subfolder: $folder`n"
    $userfile = Read-Host -Prompt "INPUT: Tell me the name of the file that contains only computernames: `n `
    EXAMPLE: 'c:\temp\mycomputers.txt'`nWARNING: Be sure that your file lists only computer hostnames and NOT FQDNs. `n `
    EXAMPLE: 'USWDCS002'" 
    If(Test-Path -LiteralPath $userfile){
        $admembers = Get-Content $userfile -ErrorAction SilentlyContinue
        }
        Else
        {
        Write-Host "No hostnames were loaded from the input file, please check your file path and try again"
        Exit
        }
    CLEAR

    }
#-----------End Wizard Interface----------------------------------#

#set our collection name
$collectionname = $groupname
#Domain prefix - double backslash is intentional, do not modify
$domainpfx = "PNKUS\\"
#AD Group name - Must include the domain prefix and groupname.
$adgroupname = $domainpfx+$groupname
#laziness with variables
$collectiongroup = $collectionname
#Limiting collection id cheatsheet
#    All Servers with client installed = "SSS0005F"
#    All Workstations with client installed = "SSS00060"
#    All Servers and Workstations = "SMSDM003"
$limitingcollectionid = "SMSDM003"
#Provide the precise AD group name
$members = "PNKUS\\$collectionname"
#update this comment for description of the group!!!
$comment = "AutoGenerated by $Scriptname for $collectionname"




#here is where the magic happens

Add-ComputerstoAdGroup -groupname $groupname -members $admembers -groupfolder $folder
Add-CollectionFromAd -collectionname $collectionname -queryname $collectionname -limitingcollectionid $limitingcollectionid -adgroupname $ADGROUPNAME


sleep -seconds 15


